# spiflash_littlefs_sfud_spi



## 用例说明

本用例演示通过 SPI 接口，使用 SFUD 组件访问 SPI Flash，使用 LittleFS 文件系统管理管理 SPI Flash 中的文件。
系统复位后，若 SPI Flash 中没有 LittleFS 文件系统时， 会进行文件系统初始化，并生成一个名为“boot_count”的文件。
系统复位后，若 SPI Flash 中存在 LittleFS 文件系统，会读取这个“boot_count”文件的值，做加一操作，并重新保存到 SPI Flash 中。

## 操作过程

+ 在PC机上启动UART串口调试终端（例如Tera Term），连接到开发板。
+ 编译本样例工程，下载可执行程序到开发板。
+ 执行本样例工程，查看串口信息。
+ 复位开发板，查看串口信息。

## 运行log

~~~bash
spi_lfs_sfud_spi example.
[SFUD]Find a flash chip. Size is 1048576 bytes.
[SFUD]SPI Flash flash device is initialize success.
../../../../../../../components/littlefs/lfs.c:1229:error: Corrupted dir pair at {0x0, 0x1}
           lfs_mount() failed.
lfs_format() done.
lfs_mount() done.
boot_count: 1
spi_spi_lfs_sfud_spi example.
[SFUD]Find a flash chip. Size is 1048576 bytes.
[SFUD]SPI Flash flash device is initialize success.
boot_count: 2
~~~
